/* CSE/ENGR 142
 *	HW5
 *	ROBERT HANCE
 *	9832306
 *	SECTION: BI
 */

#include "gp142.h"
#include <math.h>
#include <time.h>


#define TRUE    		1
#define FALSE   		0


/*  Different statuses  */
#define STATUS_ADD_SHAPE 1		/* "add shape" pressed				*/
#define STATUS_SELECTED 2		/* object selected					*/
#define STATUS_ADD_MESSAGE 3	/* "add message" pressed			*/
#define STATUS_ROTATE 4			/* not in use						*/
#define STATUS_CLEAR_SCREEN 5	/* clears screen and arrays			*/
#define STATUS_SELECTING 6		/* "select object" pressed			*/
#define STATUS_TOO_MANY 7		/* more than 20 objects placed		*/
#define STATUS_UNDO 8			/* "undo last" button pressed		*/
#define STATUS_PSYCHO 9			/* threw this in just for run		*/
#define STATUS_MOVE 10
#define STATUS_DEFAULT 11


#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

#define NUM_OF_BUTTONS 	10
#define SELECTED_COLOR  RED

/* card dimensions */
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH + 100)
#define PAGE_LLY (-GP142_YMAX + 100)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY - 50)

#define FILL 0
#define NOFILL 1

#define OBJECT_NONE 0
#define OBJECT_SHAPE 1
#define OBJECT_MESSAGE 2

#define NUM_SHAPES 4
#define MAX_OBJECTS 20
#define NUM_MESSAGES 4
#define FIRST_SHAPE_NUM 0

#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_STAR2 2
#define SHAPE_FLOWER 3
#define MESSAGE1 4
#define MESSAGE2 5
#define MESSAGE3 6
#define MESSAGE4 7

#define CLICK_BUTTON 1  
#define CLICK_CARD 2    
#define CLICK_OUTSIDE 3	
#define CLICK_POPUP 4


/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
void DrawBlankScreen (void);
void ClearScreen(void);
void DrawButtons(int last_button);
void DrawCard (int background_color, int status, int *object_count, 
			   int object_type, int object_num[], 
			   int object_color[], int object_x[], int object_y[]);
void DrawShape(int shape_type, int color, int bottom_x, int bottom_y, int object_count);
void DrawHeart (int x, int y, int color);
void DrawStar (int x, int y, int color);
void DrawStar2 (int x, int y, int color);
void DrawFlower(int x, int y, int color);

/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int *object_type, 
					  int *object_num, int *object_color, 
					  int *object_x, int *object_y, int *last_button);

int ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_type, int object_num[], int object_color[], int *object_count,
				  int selected_num, int *last_button, int selected_type, int object_x[],
				  int object_y[]);

/* Add a shape to the card. */
void AddShape(int x, int y, int *status, int *object_count, 
			   int *object_type, int *object_num, int *object_color, 
			   int *object_x, int *object_y, int *selected_num, int *selected_type);


int selected_num = 0;  /* I know universal variables are bad, but since
						  this is a specific variable, I figured I could get
						  away with it.  That, and it wouldn't work otherwise :)  */


int selected_type = OBJECT_SHAPE;  /* same story here */
/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{

	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;                  /* which key was hit            */
	int i = 0;					   /* array index				   */
	
	/*variables and their default values*/
	int background_color = YELLOW;
	int status = STATUS_ADD_SHAPE;
	int font_size = 12;	

	int object_count = 0;           
	int object_type = OBJECT_NONE;   
	int object_num[MAX_OBJECTS];     /* Type of object			      */
	int object_color[MAX_OBJECTS];   /* Color of object               */
	int object_x[MAX_OBJECTS];       /* Position of object            */
	int object_y[MAX_OBJECTS];
	
	int last_button = 1;            /* Keep track of the last button clicked.  */

	int event; /*the most recent GP142 event*/
	
	time_t t; 
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    /* Seed the random number generator. This is  */
	

	/* These GP142 initializations don't need to be changed */

	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */
	
	
	
	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 */

	while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawCard (background_color, status, &object_count, 
			      object_type, object_num, object_color, 
				  object_x, object_y);
		DrawButtons(last_button); /* draws the buttons...*/ 


		/*Wait for something to happen */
		
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
		
		switch (event) 
		{
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
			
		case GP142_KBD: 
			break;
			
		case GP142_MOUSE:

			HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
					         &object_count, &object_type, 
							 object_num, object_color, 
							 object_x, object_y, &last_button);
			break;
			
		case GP142_PERIODIC:
			/* decided not to use this */		
			break;

		default:
			
			break;
		

		}  /*end switch */


	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


void DrawBlankScreen (void) 
{
	int font_size = 14;

	GP142_rectangleXY (WHITE,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);

} /*end DrawBlankScreen */


/* 
 * Draws the buttons 
 */

#define NUM_POPUPS 4
void DrawButtons(int last_button)
{

	char b_labels [NUM_OF_BUTTONS][25] = 
	{
		"Card Color",
		"Add Shape",
		"Add Message",
		"Select Object",
		"Next",
		"Object Color",
		"Move Object",
		"Clear Card",
		"Undo Object",
		"Psychadelic"
	};
	
	int i, text_offset = -GP142_XMAX + 12, button_font_size = 12;
	int button_y, label_y;
	
	for(i = 0; i < NUM_OF_BUTTONS; i++) 
	{
		button_y = GP142_YMAX - i * BUTTON_HEIGHT - 5;
		

		
		label_y = button_y - 25;
		
		if (i == last_button)  /* give the "pressed button" effect */
		{
			
			GP142_rectangleXY(BLACK,
							-GP142_XMAX + 5,
							button_y - 2,
							-GP142_XMAX + BUTTON_WIDTH + 2,
							button_y - BUTTON_HEIGHT - 2, 2);
			
			GP142_rectangleXY(LT_GRAY,
							-GP142_XMAX + 5,
							button_y - 3,
							-GP142_XMAX + BUTTON_WIDTH - 1,
							button_y - BUTTON_HEIGHT, FILL);

			GP142_rectangleXY(WHITE,
							-GP142_XMAX + 5,
							button_y - 4,
							-GP142_XMAX + BUTTON_WIDTH,
							button_y - BUTTON_HEIGHT, FILL);


			GP142_printfXY(SELECTED_COLOR, text_offset, label_y, button_font_size, b_labels[i]);
		}
		
		else  /* button wasn't last one pressed */
		{
			
			GP142_rectangleXY(BLACK,
							-GP142_XMAX + 6,
							button_y,
							-GP142_XMAX + BUTTON_WIDTH + 2,
							button_y - BUTTON_HEIGHT - 2, 2);
			GP142_rectangleXY(WHITE,
							-GP142_XMAX + 5,
							button_y - 1,
							-GP142_XMAX + BUTTON_WIDTH - 1,
							button_y - BUTTON_HEIGHT, FILL);
			
			GP142_rectangleXY(LT_GRAY,
							-GP142_XMAX + 6,
							button_y - 3,
							-GP142_XMAX + BUTTON_WIDTH - 1,
							button_y - BUTTON_HEIGHT, FILL);
		
			GP142_printfXY(BLUE, text_offset, label_y, button_font_size, b_labels[i]);	
		} /* end else */

	}	/* end for */
	
}




/*
 *  DRAW_CARD
 */
void DrawCard (int background_color, int status, int *object_count, 
			   int object_type, int object_num[], 
			   int object_color[], int object_x[], int object_y[])
{
	int i;	

	if (status == STATUS_PSYCHO)
	{
		background_color += (rand() % MAX_COLORS);
	}

	GP142_rectangleXY (background_color,
		PAGE_LLX , PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
		FILL);
	
	/* 
	 * Draw a shape on the card.
	 */
	if (object_type == OBJECT_SHAPE || object_type == OBJECT_MESSAGE) 
	{
		for (i = 0; i < *object_count; i++)
		DrawShape (object_num[i], object_color[i],
				   object_x[i], object_y[i], *object_count);
	}
		
		

	/*
	 * Write an appropriate status message below the background
	 */
	
	GP142_printfXY(BLUE, PAGE_LLX - 10, GP142_YMAX - 50, 21, 
					"Personalized Valentine's Day Card");

	if (status != STATUS_SELECTING && status != STATUS_SELECTED)
	{
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-65, 18,
					"To change an object's attributes, click Select Object");
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-85, 18,
					"Then click on the object you wish to change");
	}
					
	switch (status) 
	{
	case STATUS_ADD_SHAPE:
		GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-40, 18,
			"Click on the card to add a shape");
		break;
	case STATUS_SELECTED:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, 18,
			"Object selected. Click button to change shape.");
		break;
	case STATUS_ADD_MESSAGE:
		GP142_printfXY(BLUE, PAGE_LLX, PAGE_LLY - 40, 18, 
			"Click on the card to add a message");
		break;
/*  case  STATUS_ROTATE:
		GP142_printfXY(BLUE, PAGE_LLX, PAGE_LLY - 40, font_size, 
			"Keep clicking ""Next"" to rotate");
		break;  */
	case STATUS_CLEAR_SCREEN:  /* "empties" the position arrays */
		for (i = 0; i < MAX_OBJECTS; i++)
		{
			object_x[i] = -999;			/* -999 makes it so that the shapes are not drawn */
			object_y[i] = -999;
		}
		*object_count = 0;
		break;
	case STATUS_SELECTING:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, 18,
			"Click near the ORIGIN of an object to select it.");
		break;
	case STATUS_TOO_MANY:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, 18,
			"Only 20 objects allowed.");
		break;
	case STATUS_UNDO:
		/*GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, 15,
			"Undo last.");*/
		break;
	case STATUS_PSYCHO:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, 18,
			"Ahh!  Click a button to make it stop!");
		break;
	case STATUS_DEFAULT:
		break;
	case STATUS_MOVE:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-40, 18,
			"Click on the card to move the selected object");
		break;
	default:
		GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY-40, 18,
			"Status error -- notify programmer");
		break;
	} /*end switch */
	
	
}


/*
 * Draw one shape.
 */
void DrawShape(int shape_type, int color, int bottom_x, int bottom_y, int object_count) 
{

	
		switch ((shape_type - FIRST_SHAPE_NUM) % 8) 
		{
		case MESSAGE1:
			GP142_printfXY (color, bottom_x - 75, bottom_y, 20,
			"Happy Valentine's Day!");
			break;
		case MESSAGE2:
			GP142_printfXY (color, bottom_x - 75, bottom_y, 20,
			"Be my Valentine");
			break;
		case MESSAGE3:
			GP142_printfXY (color, bottom_x - 50, bottom_y, 20,
			"Hallmark (R)");
			break;
		case MESSAGE4:
			GP142_printfXY (color, bottom_x - 25, bottom_y, 20,
			"B-MINE");
			break;
		case SHAPE_HEART:
			DrawHeart (bottom_x, bottom_y, color);
			break;
		case SHAPE_STAR:
			DrawStar (bottom_x, bottom_y, color);
			break;
		case SHAPE_STAR2:
			DrawStar2(bottom_x, bottom_y, color);
			break;
		case SHAPE_FLOWER:
			DrawFlower(bottom_x, bottom_y, color);
			break;
		default:
			/* Unknown shape selected */
			break;
		} /*end switch*/
	

}



#define HEART_WIDTH 35
void DrawHeart (int x, int y, int color) 
{

	int i = 0;
	

	
	
	int h = (HEART_WIDTH/2) + (rand () %12);

	GP142_circleXY (color, x - h + 5, y, h);
	GP142_circleXY (color, x + h - 5, y, h);
	GP142_triangleXY (color, x- h*2 +5, y-5,
						x + h*2 -5, y-7,
						x, y - h*2 -7, FILL);

}


#define MAXSTARS 2
void DrawStar2(int x, int y, int color)
{
	int h;
	int i, blah;
	for ( i = 0; i < MAXSTARS; i++)
	{
		h = (rand() % 20);

		GP142_triangleXY(color, x + h/2, y + h/2, x - h/2, y + h/2, x , y + h*3, FILL);
		GP142_triangleXY(color, x + h/2, y + h/2, x + h/2, y - h/2, x + h/2 + h*2, y + h/2, FILL);
		GP142_triangleXY(color, x + h/2, y - h/2, x - h/2, y - h, x + h*2, y - h*3, FILL);
		GP142_triangleXY(color, x + h/2, y - h, x - h/2, y - h/2, x - h*2, y - h*3, FILL);
		GP142_triangleXY(color, x - h/2, y + h/2, x - h/2, y - h/2, x - h/2 - h*2, y + h/2, FILL);
		GP142_rectangleXY(color, x + h/2, y + h/2, x - h/2, y-h, FILL);
	

	blah = rand() % 4;  /* random placement (++, --, +-, -+ the x,y values) */
	
	switch (blah)
	{
	case 0:
		x = x - (rand() % 50);
		y = y + (rand() % 50);
		break;
	case 1:
		x = x + (rand() % 50);
		y = y - (rand() % 50);
		break;
	case 2:
		x = x + (rand() % 50);
		y = y + (rand() % 50);
		break;
	case 3:
		x = x - (rand() % 50);
		y = y - (rand() % 50);
		break;
	}

		
	}
}



#define STARPOINTS 5
#define STARRADIUS 100
#define PI 3.1416
void DrawStar (int x, int y, int color) {

	int sp;
	double angle;
	int x1, y1;

	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);

	}
}

void DrawFlower(int x, int y, int color)
{
	int pedal_color = color - 2;

	GP142_ovalXY(pedal_color, x + 50, y - 15, x + 5, y + 15, FILL);
	GP142_ovalXY(pedal_color, x - 50, y - 15, x - 5, y + 15, FILL);
	GP142_ovalXY(pedal_color, x - 15, y + 50, x + 15, y + 5, FILL);
	GP142_ovalXY(pedal_color, x - 15, y - 50, x + 15, y - 5, FILL);
	GP142_ovalXY(color, x + 15, y + 15, x - 15, y - 15, FILL);
	
}

/*
 * Mouse clicks occur in one of three regions of interest: on buttons, 
 * on the card, or anywhere else.
 */
int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_OF_BUTTONS*BUTTON_HEIGHT)))
    return CLICK_BUTTON;
  else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
	  && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
    return CLICK_CARD;
  else
    return CLICK_OUTSIDE;

}


/*
 * Decide where a mouse click occured, and react appropriately.
 */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int *object_type, 
					  int object_num[], int object_color[], 
					  int object_x[], int object_y[], int *last_button)
{



	int mouse_click;
	int i;	


	
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	
	


    if (mouse_click == CLICK_BUTTON) 
	{
				
		/* A button has been clicked.  Call a function to handle it*/
		/* most of the variables passed as args will NOT change*/
		HandleButton(mouse_x, mouse_y, background_color, status, 
					 object_type, object_num, 
					 object_color, object_count, selected_num, last_button, selected_type,
					 object_x, object_y);
	} 
	

	else if (mouse_click == CLICK_CARD && (*status == STATUS_ADD_SHAPE 
		|| *status == STATUS_ADD_MESSAGE)) 
	{
		
		AddShape(mouse_x, mouse_y, status, object_count, 
			object_type, &object_num[*object_count], &object_color[*object_count], 
			   &object_x[*object_count], &object_y[*object_count], &selected_num, &selected_type);
		if (*status == STATUS_ADD_SHAPE && *object_count == 1)
			selected_type = OBJECT_SHAPE;
		else if (*status == STATUS_ADD_MESSAGE && *object_count == 1)
			selected_type = OBJECT_MESSAGE;

	
	}
	
	/* this next chunk of code is a little messy, but it's the cleanest i could make it */

	else if (mouse_click == CLICK_CARD && *status == STATUS_SELECTING)
	{
		for (i = 0; i < *object_count; i++)
		{
			if (mouse_x > (object_x[i] - 50) && mouse_x < (object_x[i] + 50)
				&& mouse_y > (object_y[i] - 50) && mouse_y < (object_y[i] + 50))
			{
				*status = STATUS_SELECTED;
				selected_num = i;
				if (object_num[i] > -1 && object_num[i] < NUM_SHAPES)
					selected_type = OBJECT_SHAPE;
				else if (object_num[i] > (NUM_SHAPES - 1) && object_num[i] < (NUM_SHAPES + NUM_MESSAGES))
					selected_type = OBJECT_MESSAGE;

			}
		} /* end for */

	} /* end else */

	if (mouse_click == CLICK_CARD && *status == STATUS_MOVE)
	{
		object_x[selected_num] = mouse_x;
		object_y[selected_num] = mouse_y;
	}
	
}

	

/* 
 * Figure out which button was clicked, if any, and do the right 
 * thing.
 */
void HandleButton(int x, int y, int *background_color, int *status,
				  int *object_type, int object_num[], int object_color[], int *object_count,
				  int selected_num, int *last_button, int selected_type, int object_x[],
				  int object_y[])
{
	
	int buttonNum = 0;


	if (x > -GP142_XMAX + BUTTON_WIDTH)  
		return ;	/*That's an error situation*/
	
	buttonNum = (GP142_YMAX - y - 5)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) 
	{
	case 0:
		/* Change the background color */
		*status = STATUS_DEFAULT;
		*background_color = (*background_color + 1) % MAX_COLORS;
		*last_button = buttonNum;
		break;
	case 1:
		/* sets status to add a shape */
		*status = STATUS_ADD_SHAPE;
		*last_button = buttonNum;
		break;
	case 2:
		/* sets status to add a message */
		*status = STATUS_ADD_MESSAGE;
		*last_button = buttonNum;
		break;
	case 3:
		/* cycles through shapes/messages */
		*status = STATUS_SELECTING;
		*last_button = buttonNum;
		break;
	case 4:
		/* clears the screen */
		if (selected_type == OBJECT_SHAPE)
			object_num[selected_num] = (object_num[selected_num] + 1)  % NUM_SHAPES;
		else if (selected_type == OBJECT_MESSAGE)
			object_num[selected_num] = 4 + ((object_num[selected_num] + 1) % NUM_MESSAGES);
		*last_button = buttonNum;
		*status = STATUS_DEFAULT;
		break;

	case 5:
		/* changes object color */
		object_color[selected_num] = (object_color[selected_num] + 1) % MAX_COLORS;
		*last_button = buttonNum;
		*status = STATUS_DEFAULT;
		break;
	case 6:
		/* allows user to move an object on the screen */
		*status = STATUS_MOVE;
		*last_button = buttonNum;
		break;

	case 7:
		/* removes last shape added */
		*status = STATUS_CLEAR_SCREEN;
		*last_button = buttonNum;
		break;

	case 8:
		/* heh...just makes crazy background colors */
		*status = STATUS_UNDO;
		object_x[*object_count - 1] = -999;
		object_y[*object_count - 1] = -999;
		if (*object_count > 0)
		*object_count -= 1;
		*last_button = buttonNum;
		break;

	case 9:
		*status = STATUS_PSYCHO;
		*last_button = buttonNum;
		break;

	default:
		*status = 999;
		/*Bad news if this is ever reached! */
		break;
	}
}

/* add a shape to the card (up to 20 shapes) */
void AddShape(int x, int y, int *status, int *object_count, 
			   int *object_type, int *object_num, int *object_color, 
			   int *object_x, int *object_y, int *selected_num, int *selected_type)

			
{
	
	if (*object_count < 20)
	{
			if (*status == STATUS_ADD_SHAPE)
			{
				*object_type = OBJECT_SHAPE;
				*object_num = SHAPE_HEART;
				*object_color = RED;
				*object_x = x;
				*object_y = y;
				*selected_num = *object_count;
				*selected_type = OBJECT_SHAPE;
			}
			else if (*status == STATUS_ADD_MESSAGE)
			{
				*object_type = OBJECT_MESSAGE;
				*object_num = MESSAGE1;
				*object_color = RED;
				*object_x = x;
				*object_y = y;
				*selected_num = *object_count;
				*selected_type = OBJECT_MESSAGE;
			}
		*object_count += 1;
	}
	else
		*status = STATUS_TOO_MANY; /* more than 20 shapes */
}
